library(startR, lib.loc = '/home/Earth/nmanuben/startR/startR.Rcheck')

shared_dir <- 

debug <- 
start_calls <-
param_dimnames <- 
fun <- 
params <- 
cores_per_node <-

args <- commandArgs(TRUE)[-1]

total_specified_dims <- length(args) / 2
chunk_indices <- args[((1:total_specified_dims) - 1) * 2 + 1]
names(chunk_indices) <- param_dimnames
chunks <- args[((1:total_specified_dims) - 1) * 2 + 2]
names(chunks) <- param_dimnames

data <- vector('list', length(start_calls))
for (input in 1:length(data)) {
  start_call <- start_calls[[input]]
  call_dims <- names(attr(start_call, 'Dimensions'))
  dims_to_chunk <- which(call_dims %in% param_dimnames)
  if (length(dims_to_chunk) > 0) {
    for (call_dim in call_dims[dims_to_chunk]) {
      start_call[[call_dim]] <- chunk(chunk_indices[call_dim], chunks[[call_dim]], 
                                      eval(start_call[[call_dim]]))
    }
  }
  data[[input]] <- eval(start_call)
}

Apply <- multiApply::Apply
res <- do.call("Apply",
               c(
                 list(data,
                      inverse_margins = attr(fun, 'target_dims'),
                      AtomicFun = "fun", 
                      parallel = cores_per_node > 1,
                      ncores = cores_per_node),
                 params
                )
              )
rm(data)
gc()
if (!is.list(res)) {
  res <- list(output1 = res)
}

filename <- ''
for (i in 1:total_specified_dims) {
  filename <- paste0(filename, param_dimnames[i], '_', chunk_indices[i], '__')
}
saveRDS(res, file = paste0(shared_dir, '/', filename, '.Rds'))

rm(res)
gc()
